Attribute VB_Name = "UnprotectModule"
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (ByRef hpvDest As Any, ByRef hpvSource As Any, ByVal cbCopy As Long)

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Const BI_RGB = &H0

Private Type TGF_COLOR
    Red As Byte
    Green As Byte
    Blue As Byte
    Reserved As Byte
End Type
Private Type COL_LONG
    Red As Long
    Green As Long
    Blue As Long
End Type
Private Type COL_SHIFT
    Red As Single
    Green As Single
    Blue As Single
End Type
Private Type TGF_PALETTE
    ColCount As Integer
    Col() As TGF_COLOR
End Type

Private Const FCC_SPRI As Long = &H49525053

Private Const PREVIEW_GAME_WIDTH As Long = &H80
Private Const PREVIEW_GAME_HEIGHT As Long = &H60
Private Const PREVIEW_LEVEL_WIDTH As Long = &H40
Private Const PREVIEW_LEVEL_HEIGHT As Long = &H30
Private Const PREVIEW_BITS As Integer = &H18
Private Const PREVIEW_ADD_BYTES As Long = ( _
    (PREVIEW_GAME_WIDTH * PREVIEW_GAME_HEIGHT) + _
    (PREVIEW_LEVEL_WIDTH * PREVIEW_LEVEL_HEIGHT)) * (PREVIEW_BITS / &H8)
Private Const SEGMENT_LAYERS = &H4
Private Const ICON_WIDTH As Integer = &H1E
Private Const ICON_HEIGHT As Integer = &H1E

Public FileSize As Long
Public FileData() As Byte
Public NewSize As Long
Public NewData() As Byte

Private FileBits As Byte
Private ImgDataPos As Long
Private FilePal As TGF_PALETTE

Private ImgHead As IMG_HEADER
Private PicSize As Long
Private PicArr() As Byte
Private PicCmpSize As Long
Private PicCmp() As Byte

'Private StatusTime As Single
Private StatusBase As String

Public Sub UnprotectGameData()

    Dim CurPos As Long
    Dim NewPos As Long
    Dim DataSize As Long
    Dim ImgPos As Long
    Dim LvlCount As Long
    Dim LvlTOC() As Long
    Dim NeedFix As Boolean
    Dim SegID(&H0 To SEGMENT_LAYERS - 1) As Integer
    Dim BMPInf As BITMAPINFOHEADER
    Dim CurLvl As Integer
    Dim BaseSeg(&H0 To SEGMENT_LAYERS - 1) As Long
    Dim BaseSegO(&H0 To SEGMENT_LAYERS - 1) As Long
    Dim TempByt As Byte
    Dim TempSht As Integer
    Dim TempLng As Long
    Dim PixToWrite As Long
    
    NewSize = FileSize * 1.5 + PREVIEW_ADD_BYTES * 2
    ReDim NewData(&H0 To NewSize - 1)
    
    CurPos = &H0
    NewPos = &H0
    
    MainForm.Status.Caption = "Copying/Fixing Header ..."
    MainForm.Status.Refresh
    
    ' Copy Header
    Call CopyMemory(NewData(NewPos), FileData(CurPos), &H166)
    NewData(CurPos + &H0) = &H47    ' Change "PAME"/"PAPP" -> "GAME"/"GAPP"
    Select Case FileData(&HF6)
    Case &H3
        FileBits = 8
    Case &H4
        FileBits = 24
    Case &H6
        FileBits = 15
    Case &H7
        FileBits = 16
    Case Else
        FileBits = 24
    End Select
    ' Address of Image-Data-Segment (at 0158) is written later
    Call CopyMemory(LvlCount, FileData(CurPos + &H15C), &H2)
    ReDim LvlTOC(&H0 To LvlCount - 1)
    Call CopyMemory(DataSize, FileData(CurPos + &H162), &H4)
    CurPos = CurPos + &H166
    NewPos = NewPos + &H166
    
    ' Skip Level-Address Table - it's written later
    Call CopyMemory(NewData(NewPos), FileData(CurPos), DataSize)
    CurPos = CurPos + DataSize
    NewPos = NewPos + DataSize
    
    TempLng = CurPos
    ' Search Image-Segment
    Do
        Call CopyMemory(SegID(&H0), FileData(CurPos + &H0), &H2)
        Call CopyMemory(DataSize, FileData(CurPos + &H2), &H4)
        CurPos = CurPos + &H6
        Select Case SegID(&H0) And &H7FFF
        Case &HA
            ImgDataPos = CurPos
        End Select
        CurPos = CurPos + DataSize
    Loop Until CBool(SegID(&H0) And &H8000)
    CurPos = TempLng
    
    ' Copy Data Segments
    ' Fixes:    - insert Game/Level Preview Bitmap after Game Icon/Level Palette
    '           - insert Object Icons (Global and In-Level)
    '           - fix Level Event Segment Structure
    ' TODO:     - Level Event Segment: insert Unknown Event Data
    MainForm.Status.Caption = "Copying Data Segments ..."
    MainForm.Status.Refresh
    ImgPos = &H0
    CurLvl = &H0
    Do
    ' --- Game Segment Loop Start ---
    Call CopyMemory(SegID(&H0), FileData(CurPos + &H0), &H2)
    Call CopyMemory(DataSize, FileData(CurPos + &H2), &H4)
    BaseSegO(&H0) = CurPos + &H6
    BaseSeg(&H0) = NewPos + &H6
    
    NeedFix = False
    Select Case SegID(&H0) And &H7FFF
    Case &H1    ' Game Icon
    Case &H2    ' Game Preview Bitmap
    Case &H3    ' Global Events (NO FIX NEEDED, unlike Level Events)
    Case &H4    ' Extension List
    Case &H5    ' Palette
    Case &H6    ' Global Objects
        NeedFix = True
    Case &H7    ' Unknown
    Case &H8    ' Level Data
        ' Level Segments need more fixes
        NeedFix = True
    Case &H9    ' File Menu
    Case &HA    ' Image Data
        MainForm.Status.Caption = "Copying Graphics ..."
        MainForm.Status.Refresh
        If ImgPos = &H0 Then
            ImgPos = NewPos
        End If
    Case &HC    ' Music Data
        MainForm.Status.Caption = "Copying Music ..."
        MainForm.Status.Refresh
    Case &HD    ' Sound Data
        MainForm.Status.Caption = "Copying Sounds ..."
        MainForm.Status.Refresh
    End Select
    If DataSize = &H0 Then NeedFix = False
    
    If NewSize < NewPos + DataSize + PREVIEW_ADD_BYTES Then
        NewSize = NewPos + DataSize + PREVIEW_ADD_BYTES * 2
        ReDim Preserve NewData(&H0 To NewSize - 1)
    End If
    If Not NeedFix Then
        DataSize = DataSize + &H6
        Call CopyMemory(NewData(NewPos), FileData(CurPos), DataSize)
        CurPos = CurPos + DataSize
        NewPos = NewPos + DataSize
    End If
    
    Select Case SegID(&H0) And &H7FFF
    Case &H1    ' Game Icon
        ' Insert Game Preview Bitmap
        TempSht = &H2   ' Segment ID for Game Preview Bitmap
        ' Generate BitmapInfoHeader Structure
        With BMPInf
            .biSize = LenB(BMPInf)
            .biWidth = PREVIEW_GAME_WIDTH
            .biHeight = PREVIEW_GAME_HEIGHT
            .biPlanes = &H1
            .biBitCount = PREVIEW_BITS
            .biCompression = BI_RGB
            .biSizeImage = .biWidth * .biHeight * (.biBitCount / &H8)
            .biXPelsPerMeter = &H0
            .biYPelsPerMeter = &H0
            .biClrUsed = &H0
            .biClrImportant = &H0
        End With
        DataSize = BMPInf.biSize + BMPInf.biSizeImage
        
        ' Copy Segment Header
        Call CopyMemory(NewData(NewPos + &H0), TempSht, &H2)
        Call CopyMemory(NewData(NewPos + &H2), DataSize, &H4)
        NewPos = NewPos + &H6
        
        ' Copy BitmapInfoHeader
        Call CopyMemory(NewData(NewPos), BMPInf, BMPInf.biSize)
        NewPos = NewPos + BMPInf.biSize
        
        ' Fill Picture Data with FF-Bytes (white)
        For TempLng = &H0 To BMPInf.biSizeImage - 1
            NewData(NewPos) = &HFF
            NewPos = NewPos + &H1
        Next TempLng
    Case &H5    ' Palette
        Call CopyMemory(TempSht, FileData(BaseSegO(&H0) + &H0), &H2)
        With FilePal
            Call CopyMemory(.ColCount, FileData(BaseSegO(&H0) + &H2), &H2)
            ReDim .Col(&H0 To .ColCount - 1)
            Call CopyMemory(.Col(&H0), FileData(BaseSegO(&H0) + &H4), TempSht)
        End With
    Case &H6    ' Global Objects
        If NeedFix Then ' avoid crashes because of empty segments
        
        StatusBase = "Fixing Global Objects"
        MainForm.Status.Caption = StatusBase & " ..."
        MainForm.Status.Refresh
        
        TempLng = FixObjects(CurPos, NewPos)
        CurPos = CurPos + &H6 + DataSize
        NewPos = NewPos + &H6 + TempLng
        
        End If
    Case &H8    ' Level Data Segment
        If NeedFix Then ' avoid crashes because of empty segments
        
        StatusBase = "Fixing Level " & Format$(CurLvl + 1) & " / " & _
                        Format$(LvlCount)
        MainForm.Status.Caption = StatusBase & " ..."
        MainForm.Status.Refresh
        
        Call CopyMemory(NewData(NewPos + &H0), SegID(&H0), &H2)
        Call CopyMemory(NewData(NewPos + &H2), DataSize, &H4)
        CurPos = CurPos + &H6
        NewPos = NewPos + &H6
        LvlTOC(CurLvl) = NewPos ' the Level-TOC points to the actual data
        
        DataSize = &H78
        Call CopyMemory(NewData(NewPos), FileData(CurPos), DataSize)
        CurPos = CurPos + DataSize
        NewPos = NewPos + DataSize + &H40   ' Add 40h empty bytes
        
        Do
        ' --- Level Segment Loop Start ---
        Call CopyMemory(SegID(&H1), FileData(CurPos + &H0), &H2)
        Call CopyMemory(DataSize, FileData(CurPos + &H2), &H4)
        BaseSegO(&H1) = CurPos + &H6
        BaseSeg(&H1) = NewPos + &H6
        
        NeedFix = False
        Select Case SegID(&H1) And &H7FFF
        Case &H0    ' Level Palette
        Case &H2    ' Level Object Definition
            NeedFix = True
        Case &H3    ' Level Object Placement
        Case &H4    ' Level Events
            NeedFix = True
        End Select
        
        If Not NeedFix Then
            DataSize = DataSize + &H6
            Call CopyMemory(NewData(NewPos), FileData(CurPos), DataSize)
            CurPos = CurPos + DataSize
            NewPos = NewPos + DataSize
        End If
        
        Select Case SegID(&H1) And &H7FFF
        Case &H0    ' Level Palette
            Call CopyMemory(TempSht, FileData(BaseSegO(&H1) + &H0), &H2)
            With FilePal
                Call CopyMemory(.ColCount, FileData(BaseSegO(&H1) + &H2), &H2)
                ReDim .Col(&H0 To .ColCount - 1)
                Call CopyMemory(.Col(&H0), FileData(BaseSegO(&H1) + &H4), TempSht)
            End With
            
            ' Insert Level Preview Bitmap
            ' (almost copy-and-paste from Game Preview Bitmap)
            TempSht = &H1   ' Segment ID for Level Preview Bitmap
            ' Generate BitmapInfoHeader Structure
            With BMPInf
                .biSize = LenB(BMPInf)
                .biWidth = PREVIEW_LEVEL_WIDTH
                .biHeight = PREVIEW_LEVEL_HEIGHT
                .biPlanes = &H1
                .biBitCount = PREVIEW_BITS
                .biCompression = BI_RGB
                .biSizeImage = .biWidth * .biHeight * (.biBitCount / &H8)
                .biXPelsPerMeter = &H0
                .biYPelsPerMeter = &H0
                .biClrUsed = &H0
                .biClrImportant = &H0
            End With
            DataSize = BMPInf.biSize + BMPInf.biSizeImage
            
            ' Copy Segment Header
            Call CopyMemory(NewData(NewPos + &H0), TempSht, &H2)
            Call CopyMemory(NewData(NewPos + &H2), DataSize, &H4)
            NewPos = NewPos + &H6
            
            ' Copy BitmapInfoHeader
            Call CopyMemory(NewData(NewPos), BMPInf, BMPInf.biSize)
            NewPos = NewPos + BMPInf.biSize
            
            ' Fill Picture Data with FF-Bytes (white)
            For TempLng = &H0 To BMPInf.biSizeImage - 1
                NewData(NewPos) = &HFF
                NewPos = NewPos + &H1
            Next TempLng
        Case &H2    ' Level Object Definition
            TempLng = FixObjects(CurPos, NewPos)
            CurPos = CurPos + &H6 + DataSize
            NewPos = NewPos + &H6 + TempLng
        Case &H4    ' Level Events
            Call CopyMemory(NewData(NewPos + &H0), SegID(&H1), &H2)
            CurPos = CurPos + &H6
            NewPos = NewPos + &H6
            
            TempLng = &H617246  ' Insert Four-Char-Code "Fra" + 00h
            Call CopyMemory(NewData(NewPos + &H0), TempLng, &H4)
            TempSht = &H217     ' Insert Unknown ID
            Call CopyMemory(NewData(NewPos + &H4), TempSht, &H2)
            NewPos = NewPos + &H6
            
            ' Copy 1st Block
            Call CopyMemory(DataSize, FileData(CurPos), &H4)
            DataSize = DataSize + &H4
            Call CopyMemory(NewData(NewPos), FileData(CurPos), DataSize)
            CurPos = CurPos + DataSize
            NewPos = NewPos + DataSize
            
            ' Copy 2nd Block
            DataSize = &H0
            Call CopyMemory(DataSize, FileData(CurPos), &H2)
            DataSize = DataSize + &H2
            Call CopyMemory(NewData(NewPos), FileData(CurPos), DataSize)
            CurPos = CurPos + DataSize
            NewPos = NewPos + DataSize
            
            ' Write 3rd Block
            DataSize = &H80
            CurPos = CurPos + &H4   ' Skip the 4 zeroed bytes
            ' TODO: insert correct data to make TGF open/edit the file
            NewPos = NewPos + DataSize
            
            ' Rewrite Event Segment Size
            DataSize = NewPos - BaseSeg(&H1)
            ' TGF is at least able to play the file,
            ' but some data must be inserted to edit it.
            ' Surprisingly MMF opens the file.
            Call CopyMemory(NewData(BaseSeg(&H1) - &H4), DataSize, &H4)
            
            Call CopyMemory(DataSize, FileData(BaseSegO(&H1) - &H4), &H4)
            CurPos = BaseSegO(&H1) + DataSize
        End Select
        ' --- Level Segment Loop End ---
        Loop Until CBool(SegID(&H1) And &H8000)
        
        ' Rewrite Level Size
        DataSize = NewPos - BaseSeg(&H0)
        Call CopyMemory(NewData(BaseSeg(&H0) - &H4), DataSize, &H4)
        
        Call CopyMemory(DataSize, FileData(BaseSegO(&H0) - &H4), &H4)
        CurPos = BaseSegO(&H0) + DataSize
        
        End If
        
        CurLvl = CurLvl + &H1
    End Select
    ' --- Game Segment Loop End ---
    Loop Until CBool(SegID(&H0) And &H8000)
    NewSize = NewPos
    
    Call CopyMemory(NewData(&H158), ImgPos, &H4)
    Call CopyMemory(NewData(&H166), LvlTOC(&H0), LvlCount * &H4&)
    
    ReDim Preserve NewData(&H0 To NewSize - 1)

End Sub

Private Function FixObjects(ByVal SegPosSrc As Long, ByVal SegPosDst As Long) As Long

    Dim CurPos As Long
    Dim NewPos As Long
    Dim IsGlbSeg As Boolean
    Dim DataSize As Long
    Dim NeedFix As Boolean
    Dim ObjSegID As Integer
    Dim BMPInf As BITMAPINFOHEADER
    Dim CurLvl As Integer
    Dim SegBase As Long
    Dim ObjBase As Long
    Dim OSegBase As Long
    Dim ObjCount As Integer
    Dim CurObj As Integer
    Dim TempByt As Byte
    Dim TempSht As Integer
    Dim TempLng As Long
    Dim PixToWrite As Long
    
    CurPos = SegPosSrc
    NewPos = SegPosDst
    SegBase = NewPos + &H6
    
    Call CopyMemory(TempSht, FileData(CurPos + &H0), &H2)
    IsGlbSeg = CBool(TempSht = &H6)
    'StatusTime = 0!
    
    Call CopyMemory(NewData(NewPos + &H0), FileData(CurPos + &H0), &H2)
    CurPos = CurPos + &H6
    NewPos = NewPos + &H6
    
    Call CopyMemory(ObjCount, FileData(CurPos + &H0), &H2)
    Call CopyMemory(NewData(NewPos), FileData(CurPos), &H4)
    CurPos = CurPos + &H4
    NewPos = NewPos + &H4
    
    For CurObj = &H0 To ObjCount - 1
    ' --- Level Object Loop Start ---
    
    'If StatusTime < Timer Then
    '    MainForm.Status.Caption = StatusBase & " - Object " & Format$(CurObj + 1) & _
    '                            " / " & Format$(ObjCount) & " ..."
    '    MainForm.Status.Refresh
    '    StatusTime = Timer + 0.1
    'End If
    
    ObjBase = CurPos
    Call CopyMemory(NewData(NewPos), FileData(CurPos), &H40)
    TempLng = NewPos + &H4
    Call CopyMemory(NewData(NewPos + &H40), TempLng, &H4)
    
    TempByt = FileData(CurPos + &H2A)
    If CBool(FileData(CurPos + &H26) And &H80) Then
        TempByt = &HFF
        If IsGlbSeg Then Stop
    End If
    CurPos = CurPos + &H44
    NewPos = NewPos + &H44
    
    If TempByt < &HFF Then
    
    Do
    ' --- Object Segment Loop Start ---
        Call CopyMemory(ObjSegID, FileData(CurPos + &H0), &H2)
        Call CopyMemory(DataSize, FileData(CurPos + &H2), &H4)
        OSegBase = NewPos + &H6
        
        NeedFix = False
        Select Case ObjSegID And &H7FFF
        Case &H0    ' Object Data
        Case &H2    ' Object Icon
            NeedFix = True
        End Select
        
        If Not NeedFix Then
            DataSize = DataSize + &H6
            Call CopyMemory(NewData(NewPos), FileData(CurPos), DataSize)
            CurPos = CurPos + DataSize
            NewPos = NewPos + DataSize
        End If
        
        Select Case ObjSegID And &H7FFF
        Case &H2    ' Object Icon
            Call CopyMemory(NewData(NewPos + &H0), ObjSegID, &H2)
            CurPos = CurPos + &H6 + DataSize    ' Datasize should be 0
            NewPos = NewPos + &H6
            
            TempLng = GetAniPicIdx(ObjBase)
            ' if TempLng = -1, a white/transparent Icon will be written
            Call DecodeImgPic(TempLng)
            Call MakeIconFromPic
            
            ' Write the Icon
            TempSht = &H0   ' A Checksum Calculation would be nice
            Call CopyMemory(NewData(NewPos + &H0), TempSht, &H2)
            TempSht = &H2   ' Unknown Byte
            Call CopyMemory(NewData(NewPos + &H2), TempSht, &H2)
            TempSht = &H2   ' Unknown Byte
            Call CopyMemory(NewData(NewPos + &H4), TempSht, &H2)
            Call CopyMemory(NewData(NewPos + &H6), PicCmpSize, &H4)
            Call CopyMemory(NewData(NewPos + &HA), ICON_WIDTH, &H2)
            Call CopyMemory(NewData(NewPos + &HC), ICON_HEIGHT, &H2)
            NewData(NewPos + &HE) = &H3 ' Unknown Byte (Values >6 cause TGF to crash)
            NewData(NewPos + &HF) = ImgHead.ImgMode ' Compression (1 = on)
            TempSht = &H0   ' Hot Spot X/Y (unused)
            Call CopyMemory(NewData(NewPos + &H10), TempSht, &H2)
            Call CopyMemory(NewData(NewPos + &H12), TempSht, &H2)
            TempSht = &H0   ' Action Point X/Y (unused)
            Call CopyMemory(NewData(NewPos + &H14), TempSht, &H2)
            Call CopyMemory(NewData(NewPos + &H16), TempSht, &H2)
            NewPos = NewPos + &H18
            
            Call CopyMemory(NewData(NewPos), PicCmp(&H0), PicCmpSize)
            NewPos = NewPos + PicCmpSize
            
            ' Rewrite Icon Segment Size
            DataSize = NewPos - OSegBase
            Call CopyMemory(NewData(OSegBase - &H4), DataSize, &H4)
        End Select
    ' --- Object Segment Loop End ---
    Loop Until CBool(ObjSegID And &H8000)
    
    End If
    ' --- Level Object Loop End ---
    Next CurObj
    
    ' Rewrite Global Object Definition Segment Size
    DataSize = NewPos - SegBase
    Call CopyMemory(NewData(SegBase - &H4), DataSize, &H4)
    
    FixObjects = DataSize

End Function

Private Function GetAniPicIdx(ByVal ObjPosBase As Long) As Long

    Dim CurPos As Long
    Dim TempByt As Byte
    Dim TempSht As Integer
    Dim TempLng As Long
    Dim AniBasePos As Long
    Dim AniPntPos As Long
    Dim CurAni As Byte
    Dim CurDir As Byte
    
    CurPos = ObjPosBase
    If FileData(CurPos + &H2A) = &HFF Or CBool(FileData(CurPos + &H26) And &H80) Then
        Stop
        GoTo ReturnError
    End If
    
    Select Case FileData(CurPos + &H2A)
    Case &H0    ' Quick Backdrop Object
        Call CopyMemory(TempSht, FileData(CurPos + &H36), &H2)
        GetAniPicIdx = TempSht
    Case &H1    ' Backdrop Object
        Call CopyMemory(TempSht, FileData(CurPos + &H36), &H2)
        GetAniPicIdx = TempSht
    Case &H2    ' Active Object
        CurPos = CurPos + &H44
        
        CurPos = CurPos + &H6 + &H2A
        
        ' Skip Sprite Header
        Call CopyMemory(TempLng, FileData(CurPos + &H0), &H4)
        If TempLng <> FCC_SPRI Then GoTo ReturnError
        Call CopyMemory(TempSht, FileData(CurPos + &H4), &H2)
        CurPos = CurPos + &H4 + TempSht
        
        AniBasePos = CurPos
        
        ' Read Animation TOC
        For CurAni = &H0 To &HF
            Call CopyMemory(TempSht, FileData(AniBasePos + &H4 + CurAni * &H2), &H2)
            If Not CBool(TempSht And &H8000) Then
                ' Pointer is valid
                AniPntPos = AniBasePos + TempSht
                For CurDir = &H0 To &H1F
                    Call CopyMemory(TempSht, FileData(AniPntPos + CurDir * &H2), &H2)
                    If Not CBool(TempSht And &H8000) Then
                        ' Pointer is valid
                        TempLng = AniPntPos + TempSht
                        Call CopyMemory(TempSht, FileData(TempLng + &H8), &H2)
                        
                        GetAniPicIdx = TempSht And &HFFFF&
                        Exit Function
                    End If
                Next CurDir
            End If
        Next CurAni
        
        GoTo ReturnError
    Case Else
        GoTo ReturnError
    End Select
    
    Exit Function

ReturnError:

    GetAniPicIdx = -1
    Exit Function

End Function

Private Sub DecodeImgPic(ByVal ImagePos As Long)

    If ImagePos = -1 Then
        ImgHead.SizeX = &H0
        ImgHead.SizeY = &H0
        Exit Sub
    End If
    
    Dim CurPos As Long
    Dim DataLen As Long
    Dim ImgData() As Byte
    Dim DispStr As String
    
    With ImgHead
        Call CopyMemory(CurPos, FileData(ImgDataPos + &H4 + ImagePos * &H8), &H4)
        CurPos = ImgDataPos + CurPos
        
        Call CopyMemory(DataLen, FileData(CurPos + &H6), &H4)
        Call CopyMemory(.SizeX, FileData(CurPos + &HA), &H2)
        Call CopyMemory(.SizeY, FileData(CurPos + &HC), &H2)
        .ImgMode = FileData(CurPos + &HF)
        Call CopyMemory(.HotSpotX, FileData(CurPos + &H10), &H2)
        Call CopyMemory(.HotSpotY, FileData(CurPos + &H12), &H2)
        Call CopyMemory(.ActPntX, FileData(CurPos + &H14), &H2)
        Call CopyMemory(.ActPntY, FileData(CurPos + &H16), &H2)
        .TransCol = &H0
        CurPos = CurPos + &H18
        
        ReDim ImgData(&H0 To DataLen - 1)
        Call CopyMemory(ImgData(&H0), FileData(CurPos), DataLen)
        
        Call LoadImgData(DataLen, ImgData(), .SizeX, .SizeY, _
                        FileBits, &H10, .ImgMode, .TransCol)
        Call DecodeImgV2
        
        Call GetDecodedPicture(PicSize, PicArr())
    End With

End Sub

Private Sub MakeIconFromPic()

    'If FileBits <> &H8 Then Stop
    
    Call ResizePic2Icon
    Call ConvertPic256
    
    With ImgHead
        .ImgMode = &H1
        Call LoadImgData(PicSize, PicArr(), .SizeX, .SizeY, _
                        &H8, &HFF, .ImgMode, .TransCol)
    End With
    
    Call EncodePictureV1
    
    Call GetDecodedPicture(PicCmpSize, PicCmp())

End Sub

Private Sub ResizePic2Icon()

    Dim COL_SIZE As Byte
    Dim SrcX As Long
    Dim SrcY As Long
    Dim DstX As Long
    Dim DstY As Long
    Dim LineSrc As Long
    Dim LineDst As Long
    Dim CurPix As Long
    Dim PixPos As Long
    Dim DstSize As Long
    Dim DstArr() As Byte
    Dim TempLng As Long
    Dim ColTransp As Long
    Dim BaseX As Long
    Dim BaseY As Long
    Dim FctX As Single
    Dim FctY As Single
    
    COL_SIZE = Int((FileBits + &H7) / &H8)
    'ColWhite = 2 ^ FileBits - 1
    ColTransp = &H0
    
    LineSrc = Int((ImgHead.SizeX * COL_SIZE + &H3) / &H4) * &H4
    LineDst = Int((ICON_WIDTH * COL_SIZE + &H3) / &H4) * &H4
    DstSize = LineDst * ICON_HEIGHT
    ReDim DstArr(&H0 To DstSize - 1)
    
    If ImgHead.SizeX <= ICON_WIDTH And ImgHead.SizeY <= ICON_HEIGHT Then
        FctX = 1
        FctY = 1
    Else
        If ImgHead.SizeX >= ImgHead.SizeY Then
            FctX = ImgHead.SizeX / ICON_WIDTH
        Else
            FctX = ImgHead.SizeY / ICON_HEIGHT
        End If
        FctY = FctX
    End If
    BaseX = (ICON_WIDTH - ImgHead.SizeX / FctX) / 2
    BaseY = (ICON_HEIGHT - ImgHead.SizeY / FctY) / 2
    
    For DstY = 0 To ICON_HEIGHT - 1
        SrcY = Fix((DstY - BaseY) * FctY)
        CurPix = SrcY * LineSrc
        PixPos = DstY * LineDst
        
        If SrcY >= 0 And SrcY < ImgHead.SizeY Then
            SrcX = 0
            For DstX = 0 To ICON_WIDTH - 1
                TempLng = Fix((DstX - BaseX) * FctX)
                If TempLng >= 0 And TempLng < ImgHead.SizeX Then
                    Do While SrcX < TempLng
                        SrcX = SrcX + &H1
                        CurPix = CurPix + COL_SIZE
                    Loop
                    
                    Call CopyMemory(DstArr(PixPos), PicArr(CurPix), COL_SIZE)
                Else
                    Call CopyMemory(DstArr(PixPos), ColTransp, COL_SIZE)
                End If
                PixPos = PixPos + COL_SIZE
            Next DstX
        Else
            For DstX = 0 To ICON_WIDTH - 1
                Call CopyMemory(DstArr(PixPos), ColTransp, COL_SIZE)
                PixPos = PixPos + COL_SIZE
            Next DstX
        End If
    Next DstY
    ImgHead.SizeX = ICON_WIDTH
    ImgHead.SizeY = ICON_HEIGHT
    
    PicSize = DstSize
    PicArr() = DstArr()

End Sub

Private Sub ConvertPic256()

    If FileBits = &H8 Then Exit Sub
    
    Dim COL_SIZE As Byte
    Dim CurX As Long
    Dim LineSrc As Long
    Dim LineDst As Long
    Dim CurPix As Long
    Dim PixPos As Long
    Dim DstSize As Long
    Dim DstArr() As Byte
    Dim ColVal As TGF_COLOR
    Dim TempLng As Long
    Dim ColMask As COL_LONG
    Dim ColShift As COL_SHIFT
    Dim ColMult As Long
    
    COL_SIZE = Int((FileBits + &H7) / &H8)
    Select Case FileBits
    Case 15
        With ColShift
            .Red = &H400 / &H8
            .Green = &H20 / &H8
            .Blue = &H1 / &H8
        End With
        With ColMask
            .Red = &H7C00&
            .Green = &H3E0&
            .Blue = &H1F&
        End With
        ColMult = &H4
    Case 16
        With ColShift
            .Red = &H800 / &H8
            .Green = &H20 / &H4
            .Blue = &H1 / &H8
        End With
        With ColMask
            .Red = &HF800&
            .Green = &H7E0&
            .Blue = &H1F&
        End With
    Case 24
        With ColShift
            .Red = &H10000 / &H1
            .Green = &H100& / &H1
            .Blue = &H1& / &H1
        End With
        With ColMask
            .Red = &HFF0000
            .Green = &HFF00&
            .Blue = &HFF&
        End With
    End Select
    LineSrc = Int((ImgHead.SizeX * COL_SIZE + &H3) / &H4) * &H4
    LineDst = Int((ImgHead.SizeX * &H1 + &H3) / &H4) * &H4
    DstSize = LineDst * ImgHead.SizeY
    ReDim DstArr(&H0 To DstSize - 1)
    
    CurX = &H0
    CurPix = &H0
    PixPos = &H0
    TempLng = &H0
    Do While CurPix < PicSize
        Call CopyMemory(TempLng, PicArr(CurPix), COL_SIZE)
        ColVal.Red = (TempLng And ColMask.Red) / ColShift.Red
        ColVal.Green = (TempLng And ColMask.Green) / ColShift.Green
        ColVal.Blue = (TempLng And ColMask.Blue) / ColShift.Blue
        DstArr(PixPos) = GetClosestColor(ColVal)
        CurX = CurX + &H1
        CurPix = CurPix + COL_SIZE
        PixPos = PixPos + &H1
        
        If CurX >= ImgHead.SizeX Then
            CurPix = Int((CurPix + &H3) / &H4) * &H4
            PixPos = Int((PixPos + &H3) / &H4) * &H4
            CurX = CurX - ImgHead.SizeX
        End If
    Loop
    
    'Open "D:\VStudio-Programme\VBasic\CEx.bmp" For Binary Access Write As #2
    '    Put #2, 1 + &H36, FilePal.Col()
    '    Put #2, 1 + &H436, DstArr()
    'Close #2
    PicSize = DstSize
    PicArr() = DstArr()

End Sub

Private Function GetClosestColor(ByRef Color As TGF_COLOR) As Byte

    Dim CurIdx As Integer
    Dim ErrC As COL_LONG
    Dim MinErrC As COL_LONG
    Dim MinIdx As Byte
    
    If Color.Red = &H0 And Color.Green = &H0 And Color.Blue = &H0 Then
        ' Check and Return the Transparent Color
        GetClosestColor = &H0
        Exit Function
    End If
    
    With MinErrC
        .Red = &HFF
        .Green = &HFF
        .Blue = &HFF
    End With
    MinIdx = &H0
    
    ' &H0 is transparent and must be skipped
    For CurIdx = &H1 To FilePal.ColCount - 1
        With FilePal.Col(CurIdx)
            If Color.Red = .Red And Color.Green = .Green And Color.Blue = .Blue Then
                MinIdx = CurIdx
                Exit For
            Else
                ErrC.Red = Abs(CInt(Color.Red) - .Red)
                ErrC.Green = Abs(CInt(Color.Green) - .Green)
                ErrC.Blue = Abs(CInt(Color.Blue) - .Blue)
                If (ErrC.Red + ErrC.Green + ErrC.Blue < _
                    MinErrC.Red + MinErrC.Green + MinErrC.Blue) Then
                    MinErrC = ErrC
                    MinIdx = CurIdx
                End If
            End If
        End With
    Next CurIdx
    
    GetClosestColor = MinIdx

End Function
